(*
 * Copyright 2009-2010, University of Copenhagen
 * Nicolas Palix
 * This file is part of Herodotos.
 *
 * Herodotos is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, according to version 2 of the License.
 *
 * Herodotos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Herodotos.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The authors reserve the right to distribute this or future versions of
 * Herodotos under other licenses.
 *)


exception Misconfiguration of string

let erase_file v1 v2 prjs patts =
  let targetlist =
    List.flatten (List.map
      (fun (p, cmds) ->
	 let datalist = Cfginit.erase_file_patt v2 cmds in
	 let (data, targets) = List.split datalist in
	 let flat_targets = List.flatten targets in
	   Printf.printf "%s:\n\t%s" p (String.concat "\n\t" data);
	   Printf.printf "\n\t%s\n" (String.concat "\n\t" flat_targets);
	   datalist
      ) prjs)
  in
  List.iter (fun (patt, data) ->
	       let datalist = String.concat "\n\t" data in
		 Printf.printf "%s:\n\t%s" patt datalist;
		 List.iter (fun d ->
			      let targets = List.assoc d targetlist in
				Printf.printf "\n\t%s" (String.concat "\n\t" targets)
			   ) data;
		 Printf.printf "\n\n"
	    ) patts

let erase_env v1 v2 v3 configfile filter =
  ignore(Config.parse_config configfile);
  if v2 then prerr_endline "Config parsing OK!";
  if v1 then Config.show_config v2 v3;
  let (prjs, patts) = Cfginit.compute_makefile () in
    erase_file v1 v2 prjs patts;
