/*
 * Copyright 2009-2010, University of Copenhagen
 * Nicolas Palix
 * This file is part of Herodotos.
 *
 * Herodotos is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, according to version 2 of the License.
 *
 * Herodotos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Herodotos.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The authors reserve the right to distribute this or future versions of
 * Herodotos under other licenses.
 */


%{

%}

%token EOF EOL
%token TTrue TFalse TSC
%token<string> TId
%token<int> TInt

%start main
%type <Ast_exist.matrix> main

%start entries
%type <Ast_exist.entry list> entries

%%

main:
   TId sep vs=separated_nonempty_list(sep,vid) EOL
    es=list(entry) list(EOL) EOF
    { (
      List.filter
	(fun vname ->
	if vname = "" then
	  false
	else
	  true
	)
	vs
	,es
      )
    }

vid:
   id=TId {id}
 |        {""}

entries:
   es=list(entry) EOF                { es     }

entry:
   id=TId sep states=separated_nonempty_list(sep,state_info) EOL
    { (id,
       List.filter
	 (fun s ->
	   match s with
	       Ast_exist.Empty -> false
	     | _ -> true
	 ) states
      )
    }

state_info:
                                     { Ast_exist.Empty    }
 | TTrue                             { Ast_exist.True     }
 | TFalse                            { Ast_exist.False    }
 | i=TInt                            { Ast_exist.Size (i) }

%inline sep:
 TSC {}
