(*
 * Copyright 2009-2010, University of Copenhagen
 * Nicolas Palix
 * This file is part of Herodotos.
 *
 * Herodotos is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, according to version 2 of the License.
 *
 * Herodotos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Herodotos.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The authors reserve the right to distribute this or future versions of
 * Herodotos under other licenses.
 *)


open Helper

let count_in bugs idx =
  List.fold_left (fun counter bug ->
		    let (_,_, _, _, bmin, bmax, _) = bug in
		      if idx >= bmin && idx <= bmax then
			counter +. 1.0
		      else
			counter
		 ) 0.0 bugs

let evolution vlist bugs _ vminopt =
  wrap_single_some (Array.init (Array.length vlist) (count_in bugs))

let xmax vers _ = ceil (get_xmax vers)
let ymax evol = (0.0, ceil (get_ymax1 evol) +. 1.0)

let dfts = ("ABS EVOLUTION", "Project", "Defect Sum", 1000.0, xmax, ymax, false, evolution)
