(*
 * Copyright 2009-2010, University of Copenhagen
 * Nicolas Palix
 * This file is part of Herodotos.
 *
 * Herodotos is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, according to version 2 of the License.
 *
 * Herodotos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Herodotos.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The authors reserve the right to distribute this or future versions of
 * Herodotos under other licenses.
 *)


open Helper

let neg_opt optvalue =
  match optvalue with
      None   -> None
    | Some v -> Some (-. v)

let evolution vlist bugs grinfo vminopt =
  let size = Array.length vlist in
  let births = Array.init (Array.length vlist) (Birth.count_new bugs) in
  let deaths = Array.init size (Death.count_death bugs size) in
  let neg_deaths = Array.map neg_opt deaths in
    combine births neg_deaths

let xmax vers _ = ceil (get_xmax vers)
let ymax evol =
  let values = get_ymax2 evol in
    (floor (snd values) -. 1.0, ceil (fst values) +. 1.0)

let dfts = ("Net increase EVOLUTION", "Project", "Net increase of defects", 1000.0, xmax, ymax, false, evolution)
