(*
 * Copyright 2009-2010, University of Copenhagen
 * Nicolas Palix
 * This file is part of Herodotos.
 *
 * Herodotos is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, according to version 2 of the License.
 *
 * Herodotos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Herodotos.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The authors reserve the right to distribute this or future versions of
 * Herodotos under other licenses.
 *)


open Helper

let ratioevol vlist bugs grinfo vminopt =
  let (_,_, _, _, _, _, factor) = grinfo in
  let sumevol = Countevol.evolution vlist bugs grinfo vminopt in
    Array.mapi (fun i wrap_sum ->
		  match wrap_sum with
		      Single (Some sum) ->
			let (_,_,_, size) = Array.get vlist i in
			  Helper.Single (Some ((sum *. factor) /. (float_of_int size)))
		    | _ -> failwith "Unexpected datatype"
	       )
      sumevol

let xmax vers _ = ceil (get_xmax vers)
let ymax evol = (0.0, get_ymax1 evol)

let dfts = ("Density EVOLUTION", "Project", "Defect density (by KLOC)", 1000.0, xmax, ymax, false, ratioevol)
