(*
 * Copyright 2009-2010, University of Copenhagen
 * Nicolas Palix
 * This file is part of Herodotos.
 *
 * Herodotos is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, according to version 2 of the License.
 *
 * Herodotos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Herodotos.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The authors reserve the right to distribute this or future versions of
 * Herodotos under other licenses.
 *)


open Helper

let get_size vlist factor initsize i =
  let (_,_,_,size) = Array.get vlist i in
    (factor *. float_of_int (size)) /. initsize -. factor

let evolution vlist _ grinfo vminopt =
  let (_,_,_,initsize) = Array.get vlist 0 in
  let (_,_, _, _, _, _, factor) = grinfo in
    wrap_single_some (Array.init (Array.length vlist) (get_size vlist factor (float_of_int initsize)))

let xmax vers _ = ceil (get_xmax vers)
let ymax evol = (0.0, get_ymax1 evol)

let dfts = ("PCT SIZE EVOLUTION", "Projects", "Percentage increase", 100.0, xmax, ymax, false, evolution)
