(*
 * Copyright 2009-2010, University of Copenhagen
 * Nicolas Palix
 * This file is part of Herodotos.
 *
 * Herodotos is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, according to version 2 of the License.
 *
 * Herodotos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Herodotos.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The authors reserve the right to distribute this or future versions of
 * Herodotos under other licenses.
 *)


type version = string * Unix.tm * int

type correl = Strict | Nocorrel | Default
type format = CSV | Org

type expression =
    Pattern of string
  | Project of string
  | Cst     of float
  | Plus  of expression * expression
  | Minus of expression * expression
  | Mul   of expression * expression
  | Div   of expression * expression

type attr =
    Color of float * float * float
  | Correl of string
  | CleanColor of float * float * float
  | PatternColor of float * float * float
  | DftPattern of string
  | Data of expression
  | Dir of string
  | SubDir of string
  | Factor of float
  | File of string option
  | Filename of bool
  | Footer of string
  | Format of string
  | Info of bool
  | DftProject of string
  | Legend of string
  | XLegend of string
  | YLegend of string
  | YLegendFactor of string
  | LineType of string
  | MarkType of string
  | MarkSize of float
  | XAxis of string
  | XMin of float
  | YAxis of string
  | Ratio of bool
  | NotExistColor of float * float * float
  | Version of int * version list
  | VMin of string
  | Author of bool
  | Prune of bool
  | SCM of string
  | SPFlags of string
  | Size of float * float
  | Sort of bool

type curve = string option * string option * attr list * Ast.pos

type group =
    GrpCurve of string * curve list
  | GrpPatt of string * Ast.pos

type subgraph =
    Curves of curve list
  | Groups of group list

type gph = attr list * subgraph
