(*
 * Copyright 2009-2010, University of Copenhagen
 * Nicolas Palix
 * This file is part of Herodotos.
 *
 * Herodotos is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, according to version 2 of the License.
 *
 * Herodotos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Herodotos.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The authors reserve the right to distribute this or future versions of
 * Herodotos under other licenses.
 *)


type orgoption =
    Line of int
  | ColB of int
  | ColE of int
  | Face of string

type pos = int * int * int
type path = string
type vname = string
type text = string
type link = path * orgoption list * text

type status =
    EMPTY
  | TODO
  | OK
  | BUG
  | FP
  | SAME
  | UNRELATED
  | UNKNOWN
  | IGNORED
  | Unknow of string

(* level * status * reason phrase * link * sub-items *)
type org = Org of int * status * text * link * orgs
and orgs = org list

type is_head = {mutable is_head: bool}

(* level * status * reason phrase * file name * version name * position * font color * link text * is_head * next bug * sub-items *)
type bug = int * status * text * path * vname * pos * string * text * is_head * next * orgs
and next = {
    mutable def: bug option
}

type bugs = bug list

type orgarray = (path list * (path, bugs) Hashtbl.t) array
